APT-GET(8)

Novembre 2008

NAME
apt-get - Utilitaire APT pour la gestion des paquets -- interface en ligne de commande.

SYNOPSIS

apt-get [-sqdyfmubV] [-o= options_de_configuration ] [-c= fichier_de_configuration ] [-t= nom_version_cible] {update | upgrade | dselect-upgrade | dist-upgrade | install paquet [ { =numéro_version_paquet | /nom_version_cible } ] ... | remove paquet... | purge paquet... | source paquet [ { =numéro_version_paquet | /nom_version_cible } ] ... | build-dep paquet... | check | clean | autoclean | autoremove | {-v | --version} | {-h | --help}}

DESCRIPTION

Apt-get est le programme en ligne de commande pour la gestion des paquets. Il peut être considéré comme l'outil de base pour les autres programmes de la bibliothèque APT. Plusieurs interfaces utilisateur existent, comme dselect(1), aptitude(8), synaptic(8) and wajig(1).

À moins que l'option -h ou --help ne soit donnée, l'une des commandes suivantes doit être présente.

update
    La commande update permet de resynchroniser un fichier d'index répertoriant les paquets disponibles et sa source. Ces fichiers sont récupérés aux endroits spécifiés dans /etc/apt/sources.list. Ainsi, lorsqu'on utilise une archive Debian, cette commande récupère les fichiers Packages.gz et les analyse de manière à rendre disponibles les informations concernant les nouveaux paquets et les paquets mis à jour. On doit toujours exécuter une commande update avant les commandes upgrade ou dist-upgrade. Veuillez noter que l'indicateur de progression d'ensemble peut être imprécis puisque la taille de ces fichiers ne peut être connue à l'avance.

upgrade
    La commande upgrade permet d'installer les versions les plus récentes de tous les paquets présents sur le système en utilisant les sources énumérées dans /etc/apt/sources.list. Les paquets installés dont il existe de nouvelles versions sont récupérés et mis à niveau. En aucun cas des paquets déjà installés ne sont supprimés ; de même, des paquets qui ne sont pas déjà installés ne sont ni récupérés ni installés. Les paquets dont de nouvelles versions ne peuvent pas être installées sans changer le statut d'installation d'un autre paquet sont laissés dans leur version courante. On doit d'abord exécuter la commande update pour que apt-get connaisse l'existence de nouvelles versions des paquets.

dselect-upgrade
    dselect-upgrade est utilisée conjointement avec dselect(1), la plus ancienne interface du projet Debian pour la gestion des paquets. La commande dselect-upgrade suit les modifications faites par dselect(1) dans le champ Status des paquets disponibles, et effectue les actions nécessaires à la réalisation de cet état (par exemple, suppression d'anciens paquets, installation de nouveaux paquets).

dist-upgrade
    La commande dist-upgrade effectue la fonction upgrade en y ajoutant une gestion intelligente des changements de dépendances dans les nouvelles versions des paquets ; apt-get possède un système « intelligent » de résolution des conflits et il essaye, quand c'est nécessaire, de mettre à niveau les paquets les plus importants avant les paquets les moins importants. Le fichier /etc/apt/sources.list contient une liste de sources où récupérer les paquets désirés. Voyez aussi apt_preferences(5) pour un mécanisme de remplacement des paramètres généraux pour certains paquets.

install
    La commande install est suivie par un ou plusieurs paquets à installer. Chaque paquet est un nom de paquet ; ce n'est pas un nom complet de fichier (par exemple, dans un système Debian GNU/Linux, on indiquera libc6 et non pas libc6_1.9.6-2.deb). Tous les paquets requis par le(s) paquet(s) que l'on veut installer sont aussi récupérés et installés. Le fichier /etc/apt/sources.list est utilisé pour retrouver les paquets désirés. Quand un trait d'union est accolé (sans espace intermédiaire) au nom d'un paquet déjà installé, ce paquet est supprimé. De même on peut ajouter un signe « + » pour désigner un paquet à installer. Cette dernière fonctionnalité peut être utilisée pour annuler les décisions prises par le système de résolution des conflits d'apt-get.

    On peut choisir d'installer une version particulière d'un paquet en faisant suivre son nom par un signe égal et par la version. Cette version sera recherchée et l'installation sera demandée. On peut aussi choisir une distribution particulière en faisant suivre le nom du paquet par une barre oblique et par le nom de la distribution ou de l'archive (stable, testing, unstable).

    Avec ces possibilités de choisir la version, de vieilles versions d'un paquet peuvent être installées. Cette fonctionnalité est donc à utiliser avec précaution.

    Cette méthode est aussi utile pour mettre à jour un ou plusieurs paquets déjà installés sans mettre à jour les autres paquets du système. À la différence de la commande « upgrade » qui installera la dernière version disponible de tous les paquets installés au moment de son exécution, « install » n'installera la nouvelle version que pour le(s) paquet(s) indiqué(s). Il suffit de fournir le nom du(des) paquet(s) à mettre à jour et si une nouvelle version est disponible, cette version (et ses dépendances, comme décrit plus haut) sera récupérée et installée.

    Enfin, le mécanisme d'apt_preferences(5) permet de créer d'autres règles pour l'installation des paquets.

    Quand aucun paquet ne correspond à l'expression donnée en paramètre et que cette expression contient l'un des caractères « . », « ? » ou « * », elle est considérée comme une expression rationnelle POSIX et elle est appliquée à tous les paquets de la base de données. Tout paquet correspondant est installé (ou supprimé). Veuillez noter que la comparaison est effectuée par sous-chaîne et « lo.* » correspond aussi bien à « how-lo » qu'à « lowest ». Si ce n'est pas le comportement souhaité, l'expression peut être ancrée avec un caractère « ^ » ou un caractère « $ », une autre possibilité étant d'utiliser une expression plus précise.

remove
    La commande remove est identique à la commande install, les paquets étant alors supprimés et non installés. Veuillez noter que la suppression d'un paquet en laisse les fichiers de configuration sur le système. Quand un signe plus est accolé (sans espace intermédiaire) au nom du paquet, le paquet est installé au lieu d'être supprimé.

purge
    La commande purge est identique à remove mais les paquets indiqués sont supprimés et purgés (leurs fichiers de configuration sont également effacés).

source
    Avec la commande source, apt-get récupère des paquets source. APT examine les paquets disponibles pour choisir le paquet source à récupérer. Il télécharge ensuite dans le répertoire courant la version la plus récente du paquet, définie par rapport à la distribution par défaut établie soit avec l'option APT::Default-Release, soit avec l'option -t ou soit par paquet avec la syntaxe paquet/version """while respect the default release""" me paraît douteux.

    Les paquets source sont gérés indépendamment des paquets binaires, avec les lignes de type deb-src dans le fichier sources.list(5). Il est donc nécessaire d'ajouter une telle ligne pour chaque dépôt pour lequel vous souhaitez pouvoir obtenir les sources. Dans le cas contraire, vous n'obtiendrez pas les mêmes sources que celles du paquet que vous avez installé ou que vous voulez installer.

    Si l'option --compile est spécifiée, le paquet est compilé en un binaire .deb avec dpkg-buildpackage. Si --download-only est spécifié, le source n'est pas décompacté.

    De la même façon qu'avec les paquets binaires, on peut récupérer une version particulière d'un paquet source en faisant suivre son nom par un signe égal et par la version. Cela permet une comparaison exacte entre le nom du paquet source et la version ; l'option correspondante est : APT::Get::Only-Source.

    Veuillez noter que les paquets source ne sont pas suivis comme le sont les paquets binaires. Ils ne sont présents que dans le répertoire courant et sont semblables à des sources téléchargées sous forme d'archives tar.

build-dep
    Avec la commande build-dep, apt-get installe ou supprime des paquets dans le but de satisfaire les dépendances de construction d'un paquet source.

check
    La commande check est un outil de diagnostic ; il met à jour le cache des paquets et cherche les dépendances défectueuses.

clean
    La commande clean nettoie le référentiel local des paquets récupérés. Elle supprime tout, excepté le fichier de verrou situé dans /var/cache/apt/archives/ et /var/cache/apt/archives/partial/. Quand APT est utilisé comme mode de dselect(1), clean est exécuté automatiquement. Quand on n'utilise pas dselect, il faut exécuter apt-get clean de temps en temps si l'on veut libérer de l'espace disque.

autoclean
    Tout comme clean, autoclean nettoie le référentiel local des paquets récupérés. La différence est qu'il supprime uniquement les paquets qui ne peuvent plus être téléchargés et qui sont inutiles. On peut ainsi contrôler la taille de ce cache sur une longue période. Tant qu'elle n'est pas activée, l'option de configuration APT::Clean-Installed empêche la suppression de paquets installés.

autoremove
    Avec la commande autoremove, apt-get supprime les paquets installés dans le but de satisfaire les dépendances d'un paquet donné et qui ne sont plus nécessaires.

OPTIONS

Toutes les options de la ligne de commande peuvent être définies dans le fichier de configuration, les descriptions indiquant l'option de configuration concernée. Pour les options booléennes, vous pouvez inverser les réglages du fichiers de configuration avec -f-,--no-f, -f=no et d'autres variantes analogues.

--no-install-recommends
    Ne pas considérer les paquets recommandés comme des dépendances à installer. Élément de configuration : APT::Install-Recommends.

-d, --download-only
    Récupération seule ; les paquets sont récupérés mais ne sont ni dépaquetés ni installés. Élément de configuration : APT::Get::Download-Only.

-f, --fix-broken
    Correction ; cette option demande de réparer un système où existent des dépendances défectueuses. Utilisée avec install ou remove, elle peut exclure un paquet pour permettre de déduire une solution viable. Tout paquet spécifié doit complètement corriger le problème. Cette option est quelquefois nécessaire lorsque l'on exécute APT pour la première fois ; APT interdit les dépendances défectueuses dans un système. Il est possible que la structure de dépendances d'un système soit tellement corrompue qu'elle requiert une intervention manuelle (ce qui veut dire la plupart du temps utiliser dselect(1) ou dpkg --remove pour éliminer les paquets en cause). L'utilisation de cette option conjointement avec -m peut produire une erreur dans certaines situations. Élément de configuration : APT::Get::Fix-Broken.

-m, --ignore-missing, --fix-missing
    Ignorer les paquets manquants ; si des paquets ne peuvent être récupérés, ou, après récupération, ne satisfont pas au contrôle d'intégrité, cette commande met ces paquets de côté et gère le résultat. Utiliser cette option conjointement avec -f peut produire une erreur dans certaines situations. Quand un paquet, sélectionné pour une installation (particulièrement si c'est mentionné en ligne de commande), ne peut être récupéré, il est mis silencieusement de côté. Élément de configuration : APT::Get::Fix-Missing.

--no-download
    Pas de récupération. Le mieux est d'utiliser cette option avec --ignore-missing pour forcer APT à n'utiliser que les .deb qu'il a déjà récupérés. Élément de configuration : APT::Get::Download.

-q, --quiet
    Mode silencieux ; cette commande produit une sortie destinée à l'enregistrement dans un fichier-journal en omettant les indicateurs de progression. Un plus grand nombre de « q » (2 au plus) produit un plus grand silence. On peut aussi utiliser -q=# pour positionner le niveau de silence, et annuler le fichier de configuration. Notez qu'un niveau de silence égal à 2 implique -y et vous ne devez jamais utiliser -qq sans l'accompagner d'un modificateur tel que -d, --print-uris ou -s : APT pourrait alors exécuter des actions inattendues. Élément de configuration : quiet.

-s, --simulate, --just-print, --dry-run, --recon, --no-act
    Pas d'action ; simule les événements qui devraient se produire sans effectuer de changement réel sur le système. Élément de configuration : APT::Get::Simulate.

    Lorsque la simulation est effectuée par un utilisateur sans privilège, le verrouillage (Debug::NoLocking) sera désactivé automatiquement. Une mention explicite indiquant qu'il s'agit d'une simple simulation sera affichée si l'option APT::Get::Show-User-Simulation-Note est activée (elle est active par défaut). Ni la désactivation du verrou ni l'affichage de la mention de simulation ne seront déclenchées si la commande est lancée par l'utilisateur root (pour qui il n'est pas jugé utile qu'apt-get envoie de telles notifications).

    La simulation affiche une série de lignes représentant chacune une opération de dpkg, Configure (Conf), Remove (Remv), Unpack (Inst). Des crochets encadrent des paquets endommagés et des crochets n'encadrant rien indiquent que les dommages n'ont aucune conséquence (rare).

-y, --yes, --assume-yes
    Répondre automatiquement oui aux questions ; présume « oui » comme réponse à toutes les questions et s'exécute de manière non interactive. Dans le cas d'une situation indésirable, comme le changement d'un paquet gelé, l'installation d'un paquet non authentifié ou la suppression d'un paquet essentiel, apt-get s'interrompt. Élément de configuration : APT::Get::Assume-Yes.

-u, --show-upgraded
    Afficher les paquets mis à niveau ; affiche une liste de tous les paquets à mettre à niveau. Élément de configuration : APT::Get::Show-Upgraded.

-V, --verbose-versions
    Afficher les versions complètes des paquets installés ou mis à niveau. Élément de configuration : APT::Get::Show-Versions.

-b, --compile, --build
    Cette commande compile un paquet source après l'avoir récupéré. Élément de configuration : APT::Get::Compile.

--install-recommends
    Installer également les paquets recommandés.

--no-install-recommends
    Ne pas installer les paquets recommandés.

--ignore-hold
    Cette commande ignore la marque « Hold » (« garder ») d'un paquet ; par ce biais, apt-get ignore un « hold » placé sur un paquet. cela peut être utile avec dist-upgrade pour annuler un grand nombre de « hold » indésirables. Élément de configuration : APT::Ignore-Hold.

--no-upgrade
    Aucune mise à niveau ; quand elle est utilisée avec install, cette commande empêche les paquets mentionnés sur la ligne de commande d'être mis à niveau. Élément de configuration : APT::Get::Upgrade.

--only-upgrade
    N'install aucun nouveau paquet ; quand elle est utilisée avec install, only-upgrade empêche les paquets mentionnés sur la ligne de commande d'être mis à niveau s'ils ne sont pas déjà installés. Élément de configuration : APT::Get::Only-Upgrade.

--force-yes
    Forcer l'acceptation ; cette option est dangereuse parce qu'elle laisse APT continuer sans poser de questions quand il réalise quelque chose de potentiellement dommageable. Cette option ne doit être utilisée que dans des circonstances très spéciales. Utiliser force-yes peut détruire le système... Élément de configuration : APT::Get::force-yes.

--print-uris
    Au lieu de récupérer les paquets à installer, leurs URI sont affichées. Chaque URI a un chemin, un nom de fichier destination, une taille et une clé md5 attendue. Veuillez noter que le nom de fichier à afficher ne correspond pas toujours au nom de fichier sur le site distant. Cette option fonctionne aussi avec la commande source et avec la commande update. Avec la commande update, la somme MD5 et la taille ne sont pas données et c'est à l'utilisateur de décompresser les fichiers compressés. Élément de configuration : APT::Get::Print-URIs.

--purge
    Utiliser « purge » à la place de « remove » pour supprimer tout ce qui peut être supprimé. Un astérisque (*) sera accolé aux noms des paquets qui vont être purgés. remove --purge est équivalent à la commande purge. Élément de configuration : APT::Get::Purge.

--reinstall
    Réinstaller les paquets déjà installés avec leur version la plus récente. Élément de configuration : APT::Get::ReInstall.

--list-cleanup
    Cette option est activée par défaut ; utilisez --no-list-cleanup pour la désactiver. Quand elle est activée, apt-get gère automatiquement le contenu de /var/lib/apt/lists afin d'assurer que les fichiers obsolètes soient effacés. La seule raison de la désactiver est une modification fréquente de la liste de sources. Élément de configuration : APT::Get::List-Cleanup.

-t, --target-release, --default-release
    Cette option contrôle l'entrée par défaut pour les questions de distribution ; une étiquette (pin) par défaut dont la priorité vaut 990 est créée en utilisant la chaîne spécifiée. Le fichier des préférences peut annuler cette décision. En clair, cette option permet de contrôler simplement dans quelle distribution seront récupérés les paquets. Par exemple : -t '2.1*', -t unstable ou -t sid. Élément de configuration : APT::Default-Release. Voyez aussi la page de manuel d'apt_preferences(5).

--trivial-only
    Ne réalise que les opérations « triviales ». Logiquement ceci peut être considéré comme relatif à --assume-yes. Alors que --assume-yes répond oui à n'importe quelle question, --trivial-only répond non. Élément de configuration : APT::Get::Trivial-Only.

--no-remove
    Arrêter immédiatement apt-get, sans poser de questions, si des paquets doivent être supprimés. Élément de configuration : APT::Get::Remove.

--auto-remove
    Si la commande utilisée est soit install soit remove, cette option a le même effet qu'autoremove et supprime les paquets de dépendance inutilisés. Élément de configuration : APT::Get::Upgrade.

--only-source
    Cette option n'a de sens qu'avec les commandes source et build-dep. Elle indique que les noms de sources donnés ne doivent pas être repérés à travers le tableau des binaires. Cela signifie que si cette option est choisie, la commande source acceptera seulement des noms de paquets source comme argument ; elle n'acceptera pas de les rechercher à partir des noms de paquets binaires correspondants. Élément de configuration : APT::Get::Only-Source

--diff-only, --dsc-only, --tar-only
    Ne télécharger que le fichier .diff, .dsc ou .tar d'une archive source. Élément de configuration : APT::Get::Diff-Only, APT::Get::Dsc-Only et APT::Get::Tar-Only,

--arch-only
    Ne traiter que les dépendances de construction dépendantes de l'architecture. Élément de configuration : APT::Get::Arch-Only.

--allow-unauthenticated
    Ignorer le fait que les paquets ne peuvent pas être authentifiés ; ne le signale pas à l'utilisateur. Cette option est très utile pour certains outils comme pbuilder. Élément de configuration : APT::Get::AllowUnauthenticated.

-h, --help
    Afficher un bref résumé de l'utilisation.

-v, --version
    Afficher la version du programme.

-c, --config-file
    Fichier de configuration ; indique le fichier de configuration à utiliser. Le programme lira le fichier de configuration par défaut puis le fichier indiqué ici. Si les réglages de configuration doivent être établis avant l'analyse des fichiers de configuration par défaut, un fichier peut être indiqué avec la variable d'environnement APT_CONFIG. Veuillez consulter apt.conf(5) pour des informations sur la syntaxe d'utilisation.

-o, --option
    Définir une option de configuration ; permet de régler une option de configuration donnée. La syntaxe est -o Foo::Bar=bar. -o et --option peuvent être utilisées plusieurs fois pour définir des options différentes.

FICHIERS

/etc/apt/sources.list
    Emplacement pour la récupération des paquets. Élément de configuration : Dir::Etc::SourceList.

/etc/apt/sources.list.d/
    Fragments de fichiers définissant les emplacements de récupération de paquets. Élément de configuration : Dir::Etc::SourceParts.

/etc/apt/apt.conf
    Fichier de configuration d'APT. Élément de configuration : Dir::Etc::Main.

/etc/apt/apt.conf.d/
    Fragments du fichier de configuration d'APT. Élément de configuration : Dir::Etc::Parts.

/etc/apt/preferences
    Fichier des préférences. C'est dans ce fichier qu'on peut faire de l'étiquetage (pinning) c'est-à-dire, choisir d'obtenir des paquets d'une source distincte ou d'une distribution différente. Élément de configuration : Dir::Etc::Preferences.

/etc/apt/preferences.d/
    Fragments de fichiers pour la préférence des versions. Élément de configuration : Dir::Etc::PreferencesParts.

/var/cache/apt/archives/
    Zone de stockage des fichiers récupérés. Élément de configuration : Dir::Cache::Archives.

/var/cache/apt/archives/partial/
    Zone de stockage pour les paquets en transit. Élément de configuration : Dir::Cache::Archives (implicitement, partial).

/var/lib/apt/lists/
    Zone de stockage pour les informations qui concernent chaque ressource de paquet spécifiée dans sources.list(5) Élément de configuration : Dir::State::Lists.

/var/lib/apt/lists/partial/
    Zone de stockage pour les informations en transit. Élément de configuration : Dir::State::Lists (implicit partial).

VOIR AUSSI

apt-cache(8), apt-cdrom(8), dpkg(1), dselect(1), sources.list(5), apt.conf(5), apt-config(8), le guide d'APT dans /usr/share/doc/apt-doc/, apt_preferences(5), le « HOWTO » d'APT.

DIAGNOSTICS

apt-get renvoie zéro après une opération normale, le décimal 100 en cas d'erreur.

AUTEURS D'ORIGINE

Jason Gunthorpe

AUTEURS ACTUELS

Équipe de développement d'APT

Page qualité[1]

BOGUES

Page des bogues d'APT[2]. Si vous souhaitez signaler un bogue à propos d'APT, veuillez lire /usr/share/doc/debian/bug-reporting.txt ou utiliser la commande reportbug(1).

TRADUCTEURS

Jérôme Marant, Philippe Batailler, Christian Perrier bubulle@debian.org (2000, 2005, 2009, 2010), Équipe de traduction francophone de Debian debian-l10n-french@lists.debian.org

Veuillez noter que cette traduction peut contenir des parties non traduites Cela est volontaire, pour éviter de perdre du contenu quand la traduction est légèrement en retard sur le contenu d'origine.

AUTHORS

Jason Gunthorpe

Équipe de développement d'APT

NOTES

1.  Page qualité
    http://packages.qa.debian.org/a/apt.html

2.  Page des bogues d'APT
    http://bugs.debian.org/src:apt